#include "cellspace.h"
#include "model.h"
#include "machine.h"
#include "string.h"

CellSpace::CellSpace(Model *parent, int w, int h)
{
    cl_int err_code;
    this->parent = parent;
    parent->addChild(this);
    which = 0;
    width = w;
    height = h;
    int size = parent->getCellSize()*w*h;
    char *data = new char[size];
    memset(data, 0, size);
    space = clCreateBuffer(parent->getParent()->getContext(), CL_MEM_READ_WRITE | CL_MEM_COPY_HOST_PTR, size, data, &err_code);
    delete data;
    if(err_code){ cerr << "Nepodarilo sa alokovat pamet"; clGetError(err_code); }
}

CellSpace::~CellSpace()
{
    parent->removeChild(this);
    clReleaseMemObject(space);
}

void CellSpace::run(int iteration)
{
    parent->run(this, which, iteration);
    which=(which+iteration)&1;//binarna hodnota
}
