#ifdef NEUMANN
__constant int2 neighbors[] = {
    0,1, -1,0, 1,0, 0,-1, 0,0 };
#define NEIGHBORS 5
#endif

#ifdef MOORE
__constant int2 neighbors[] = {
    -1,1, 1,1, -1,-1, 1,-1, 0, 1, -1,0, 1,0, 0,-1, 0,0 };
#define NEIGHBORS 9
#endif

int wrap(int x, int y)
{
    int r = (x < 0) ? x+y : x;
    return (r < y ? r : r-y);
}

int2 wrap2(int2 x, int2 y)
{
    return (int2)(wrap(x.x, y.x), wrap(x.y, y.y));
}

__kernel void takeStep(__global int *cells, int which)
{
    size_t x = get_global_id(0);
    size_t y = get_global_id(1);
    size_t w = get_global_size(0);
    size_t h = get_global_size(1);
    int2 coord = (int2)(x, y);
    int2 sizes = (int2)(w, h);
    //if(x==0&&y==0)printf("lol %d\n", which);

    int node = sizeof(rule_tree)/sizeof(int) - NUM_STATES;
    int state;
    for(int i=0;i<NEIGHBORS;i++)
    {
        int2 c = wrap2(coord+neighbors[i], sizes);

        state = cells[(c.y*w+c.x)*2+which];
        node = rule_tree[node+state];
    }
    which = (which+1)&1;
    cells[(y*w+x)*2] = node;
}

/*__kernel void image_write(__write_only image2d_t img)
{
    size_t x = get_global_id(0);
    size_t y = get_global_id(1);
    int2 c = (int2)(x,y);
    uint4 col = (uint4)(x, y, x, y);
    write_imageui(img, c, col);
}*/

__kernel void image_write(__global uint *data, __write_only image2d_t img)
{
    sampler_t sampl = CLK_NORMALIZED_COORDS_FALSE | CLK_ADDRESS_NONE | CLK_FILTER_NEAREST;
    size_t x = get_global_id(0);
    size_t y = get_global_id(1);
    /*uint4 col = read_imageui(img, sampl, (int2)(x,y));
    data[x*256+y] = col.w*256*256*256+col.x*256*256+col.y*256+col.z;*/
    write_imagef(img, (int2)(x,y), (float4)(x/256.0f, y/256.0f, x/256.0f, y/256.0f));//toto funguje
    //write_imageui(img, (int2)(x,y), (uint4)(x, y, x, y));//toto nefunguje
    //write_imagei(img, (int2)(x,y), (uint4)(x-128, y-128, x-128, y-128));//toto nefunguje tiez
}
