#ifndef _MODEL_H_NOU_
#define _MODEL_H_NOU_

#include <string>
#include <vector>
#include <CL/cl.h>
#include "cellspace.h"

using namespace std;

class Machine;

class Model
{
    private:
    cl_program program;
    vector<CellSpace*> patterns;
    public:
    Model(Machine *parent);
    virtual ~Model();
    Machine* getParent(){ return parent; }
    void addChild(CellSpace *child);
    void removeChild(CellSpace *child);
    cl_kernel getKernel(CellSpace *pattern);
    virtual void run(CellSpace *pattern, int which, int iteration = 1) = 0;
    virtual int getCellSize() = 0;
    virtual void loadSource() = 0;
    unsigned char* image();
    protected:
    cl_int build(string source, string options);
    cl_kernel kernel;
    Machine *parent;
};

class SynchronousModel : public Model
{
    public:
    SynchronousModel(Machine *parent, string model_definition);
    int getCellSize(){ return sizeof(int)*2; }
    void loadSource();
    void run(CellSpace *pattern, int which, int iteration = 1);
    private:
    string source;
};

#endif // _MODEL_H_NOU_
